/* Copyright (C) 2008 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2002 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1994 DJ Delorie, see COPYING.DJ for details */
#include "libsupp.h"
#include "../include/libc/file.h"


int
libsupp_fprintf(register FILE *iop, const char *fmt, ...)
{
  va_list args;
  int len;
  char localbuf[BUFSIZ];

  va_start(args, fmt);

  if (iop->_flag & _IONBF)
  {
    iop->_flag &= ~_IONBF;
    iop->_ptr = iop->_base = localbuf;
    iop->_bufsiz = BUFSIZ;
    len = libsupp__doprnt(fmt, args, iop);
    fflush(iop);
    iop->_flag |= _IONBF;
    iop->_base = NULL;
    iop->_bufsiz = 0;
    iop->_cnt = 0;
  }
  else
    len = libsupp__doprnt(fmt, args, iop);

  va_end(args);

  return ferror(iop) ? EOF : len;
}
