/* Copyright (C) 2009 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 2003 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1999 DJ Delorie, see COPYING.DJ for details */
/* Copyright (C) 1995 DJ Delorie, see COPYING.DJ for details */
#include <libc/stubs.h>
#include <unistd.h>
#include <io.h>
#include <errno.h>

#include "../include/libc/fd_props.h"
#include "libsupp.h"

int
libsupp_ftruncate(int fd, off_t where)
{
  off_t here;
  int retval = 0;

  /* Directory? If so, fail. */
  if (libsupp___get_fd_flags(fd) & FILE_DESC_DIRECTORY)
  {
    errno = EINVAL;
    return -1;
  }

  here = libsupp_lseek(fd, 0, SEEK_CUR);
  if (here == -1)
    return -1;
  if (libsupp_lseek(fd, where, SEEK_SET) == -1)
    return -1;
  if (libsupp__write(fd, 0, 0) < 0)
    retval = -1;
  libsupp_lseek(fd, here, SEEK_SET);
  return retval;
}
